require("Lib.Vector")
require("Lib.30log")
require("Debug/debug")
require("UI.Gui")
require("MapLoader")
require("Lib.lib")
require("StateManager")
loveframes = require("Lib.Loveframes")



function love.load()
  
  math.randomseed(os.time())
  
  map = MapLoader:new(960, 640, 16, 16, 1)
  
--Window Setup
  love.window.setMode(map.map_pixels.w, map.map_pixels.h)
  
  -- UI setup
  gui = Gui:new(loveframes)
  
  stateManager = StateManager:new(map, gui)
  stateManager:start()
end


---Update the objects before display is updated
function love.update(dt)
  loveframes.update(dt)
  stateManager:update()
end
  
  
---Draw Graphics to Screen
function love.draw()
  loveframes.draw()
  stateManager:draw()
end


--- UI Input Detection
function love.mousepressed(x,y, button)
  loveframes.mousepressed(x,y, button)
end

function love.mousereleased(x,y,button)
  loveframes.mousereleased(x,y,button)
end

function love.keypressed(key, unicode)
  loveframes.keypressed(key, unicode)
end

function love.keyreleased(key, unicode)
  loveframes.keyreleased(key,unicode)
end

function love.textinput(text)
  loveframes.textinput(text)
end